<?php
/**
  Module developed for the Open Source Content Management System Website Baker (http://websitebaker.org)
  Copyright (C) 2012, Andreas Schmidt
  Contact me: webmaster(at)hillschmidt.de, http://www.hillschmidt.de

  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License  - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
**/

// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));

// include core functions of WB 2.7 to edit the optional module CSS files (frontend.css, backend.css)
@include_once(WB_PATH .'/framework/module.functions.php');

// check if module language file exists for the language set by the user (e.g. DE, EN)
if(!file_exists(dirname(__FILE__) .'/languages/' .LANGUAGE .'.php')) {
// no module language file exists for the language set by the user, include default module language file EN.php
        require_once(dirname(__FILE__) .'/languages/EN.php');
} else {
// a module language file exists for the language defined by the user, load it
        require_once(dirname(__FILE__) .'/languages/' .LANGUAGE .'.php');
}

// check if backend.css file needs to be included into the <body></body> of modify.php
if(!method_exists($admin, 'register_backend_modfiles') && file_exists(dirname(__FILE__) .'/backend.css')) {
        echo '<style type="text/css">';
        include(dirname(__FILE__) .'/backend.css');
        echo "\n</style>\n";
}

// obtain data from module DB-table of the current displayed page (unique page defined via section_id)
$sql_result = $database->query("SELECT * FROM `" .TABLE_PREFIX ."mod_quiz` WHERE `section_id` = '$section_id'");

// store all results (fields) in the array $sql_row
$sql_row = $sql_result->fetchRow();

// check if the DB-Field name contains a value, if not use Quiz Name as default value.
if ($sql_row['name'] == '') {
        $sql_row['name'] = 'Quiz Name';
} else {
// Note: before displaying a string in a text field, one needs to convert special characters into entities.
// Characters like " do not show up in text fields if not converted to entities.
// This also prevents that embedded Javascript/PHP/HTML tags are parsed by the browser.
        $sql_row['name'] = htmlspecialchars($sql_row['name']);
}
        // write out heading
        echo "<h2>" .$MOD_QUIZ['TXT_HEADING_B'] ."&nbsp;<font class=\"mod_quiz_name_disp_b\">" .$sql_row['name']. "</font></h2>\n";

        // include the button to edit the optional module CSS files (function added with WB 2.7)
        // Note: CSS styles for the button are defined in backend.css
        //       (div class="mod_moduledirectory_edit_css")
        // Place this call outside of any <form></form> construct!!!
        if(function_exists('edit_module_css')) {
                edit_module_css('quiz');
        }
        echo "<br /><br />\n";

        // copied and modified above to edit the quiz data file directly - NOT RECOMMENDED but useful!
        if(function_exists('edit_module_datafile')) {
                edit_module_datafile('quiz');
        }
        echo "<br /><br />\n";

        // Open the quiz file, gets the content and close it
        $datei=dirname(__FILE__) .'/data/' .$page_id .'.' .$section_id .'.txt';
        $handler=fOpen($datei,"a+");
        $array=file($datei);
        fClose ($handler);

        // Create the score file if not exist
        $datei2=dirname(__FILE__) .'/data/' .$page_id .'.' .$section_id .'.score.txt';
        $handler2=fOpen($datei2,"a+");
        //$array=file($datei2);
        fClose ($handler2);

        // create the form with text outputs and buttons below using mixed HTML and PHP code
        ?>
        <form name="edit" onsubmit="return mod_quiz_validateInput_b(<?php echo count($array) .",'" .LANGUAGE ."'"; ?>);" action="<?php echo WB_URL; ?>/modules/quiz/save.php" method="post">
        <input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
        <input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
        <?php echo $MOD_QUIZ['TXT_INPUT_DESC_B']; ?>:
        <input name="name" type="text" value="<?php echo $sql_row['name']; ?>" class="mod_quiz_name_b" /><br />
        <?php echo $MOD_QUIZ['TXT_RADIO_SOL_B']; ?>:
        <input name="display" type="radio" value="0" <?php if ($sql_row['display'] == 0) echo 'checked="checked"'; ?> />
        0 = <?php echo $MOD_QUIZ['TXT_RADIO_SOL_N_B']; ?>
        <input name="display" type="radio" value="1" <?php if ($sql_row['display'] == 1) echo 'checked="checked"'; ?> />
        1 = <?php echo $MOD_QUIZ['TXT_RADIO_SOL_Y_B']; ?><br />
        <?php echo $MOD_QUIZ['TXT_RATE_B']; ?>:
        <input name="rate" type="text" size="3" maxLength="3" value="<?php echo $sql_row['rate'] ?>" /> %<br />
        <?php
        if (count($array) == 0)   // NO questions do exist: open empty form
        {
         for ($counter=0;$counter<1;$counter++)
         {
          echo "<hr noshade=\"noshade\" size=\"1\" align=\"center\" />
          <table summary=\"emptyFields\"><!--td>" .$counter ."</td-->
          <tr><td colspan=\"3\">" .$MOD_QUIZ['TXT_INPUT_PIC'] .":<br />
          <input type=\"text\" name=\"QuestPic" .$counter ."\" value=\"[[image?image=picture]]\" class=\"mod_quiz_image_b\" /></td></tr>
          <tr><td colspan=\"3\"><i style=\"font-size:smaller;\">" .$counter ."</i> <input type=\"text\" name=\"Quest" .$counter ."\" value=\"\" class=\"mod_quiz_quest_b\" /></td></tr>
          <tr><td><input type=\"radio\" name=\"K" .$counter ."\" value=\"1\" /><input type=\"text\" name=\"F" .$counter ."A1\" value=\"\" /></td>
          <td><input type=\"radio\" name=\"K" .$counter ."\" value=\"2\" /><input type=\"text\" name=\"F" .$counter ."A2\" value=\"\" /></td>
          <td><input type=\"radio\" name=\"K" .$counter ."\" value=\"3\" /><input type=\"text\" name=\"F" .$counter ."A3\" value=\"\" /></td></tr>
          <tr><td><input type=\"radio\" name=\"K" .$counter ."\" value=\"4\" /><input type=\"text\" name=\"F" .$counter ."A4\" value=\"\" /></td>
          <td><input type=\"radio\" name=\"K" .$counter ."\" value=\"5\" /><input type=\"text\" name=\"F" .$counter ."A5\" value=\"\" /></td>
          <td><input type=\"radio\" name=\"K" .$counter ."\" value=\"6\" /><input type=\"text\" name=\"F" .$counter ."A6\" value=\"\" /></td></tr>
          <tr><td><input type=\"hidden\" name=\"F" .$counter ."Sol\" /></td></tr></table>\n";
         };
        }
        else   // Questions exist: open form with the exisiting entries
        {
         for ($counter=0;$counter<count($array);$counter++)
         {
          // split the data
          $question=explode("|",$array[$counter]);
          // prepare an array for the RIGHT ANSWER checked radio button
          $Correct=array("dummy","","","","","","");
          // corresponding field for the right answer given in $question[8] is set to checked
          $Correct[$question[8]]='checked="checked"';
          echo "<hr noshade=\"noshade\" size=\"1\" align=\"center\" />
          <table summary=\"filledFields\"><!--td>" .$counter ."</td-->
          <tr><td colspan=\"3\">" .$MOD_QUIZ['TXT_INPUT_PIC'] .":<br />
          <input type=\"text\" name=\"QuestPic" .$counter ."\" value=\"" .$question[9] ."\" class=\"mod_quiz_image_b\" /></td></tr>
          <tr><td colspan=\"3\"><i style=\"font-size:smaller;\">" .$counter ."</i> <input type=\"text\" name=\"Quest" .$counter ."\" value=\"" .$question[1] ."\"  class=\"mod_quiz_quest_b\" /></td>
          <td rowspan=\"3\"><input type=\"checkbox\" name=\"delQuest\" onclick=\"mod_quiz_delQuest_b(" .$counter .");\" />" .$MOD_QUIZ['TXT_DEL_QUEST_B'] ."</td></tr>
          <tr><td><input type=\"radio\" name=\"K" .$counter ."\" value=\"1\" " .$Correct[1] ." /><input type=\"text\" name=\"F" .$counter ."A1\" value=\"" .$question[2] ."\" /></td>
          <td><input type=\"radio\" name=\"K" .$counter ."\" value=\"2\" " .$Correct[2] ." /><input type=\"text\" name=\"F" .$counter ."A2\" value=\"" .$question[3] ."\" /></td>
          <td><input type=\"radio\" name=\"K" .$counter ."\" value=\"3\" " .$Correct[3] ." /><input type=\"text\" name=\"F" .$counter ."A3\" value=\"" .$question[4] ."\" /></td></tr>
          <tr><td><input type=\"radio\" name=\"K" .$counter ."\" value=\"4\" " .$Correct[4] ." /><input type=\"text\" name=\"F" .$counter ."A4\" value=\"" .$question[5] ."\" /></td>
          <td><input type=\"radio\" name=\"K" .$counter ."\" value=\"5\" " .$Correct[5] ." /><input type=\"text\" name=\"F" .$counter ."A5\" value=\"" .$question[6] ."\" /></td>
          <td><input type=\"radio\" name=\"K" .$counter ."\" value=\"6\" " .$Correct[6] ." /><input type=\"text\" name=\"F" .$counter ."A6\" value=\"" .$question[7] ."\" /></td></tr>
          <tr><td><input type=\"hidden\" name=\"F" .$counter ."Sol\" /></td></tr></table>\n";
         };
        }
        echo "<hr />
        <p><input name=\"new\" type=\"radio\" value=\"newQuest\" />" .$MOD_QUIZ['TXT_NEW_QUEST_SAVE_B'] ."</p>\n
        <p><input name=\"save\" type=\"submit\" value=\"" .$MOD_QUIZ['TXT_SAVE_B'] ."\" onclick=\"mod_quiz_setSol_b(" .$counter .");\" /></p>\n";
        ?>
        </form>
<?php
// The following function was introduced to edit the quiz file directly!
// Although this is not really recommended, it maybe helpful under special circumstances!!!
// ATTENTION: works only if you change the line 80 in /modules/edit_module_files.php from
//    $css_file = (in_array($_edit_file, array('frontend.css', 'backend.css'))) ? $_edit_file : '';
// to
//    $css_file = (in_array($_edit_file, array('frontend.css', 'backend.css'))) ? $_edit_file : $_edit_file;

function edit_module_datafile($mod_dir)
{
         global $page_id, $section_id, $MOD_QUIZ;
         // check if the required edit_module_css.php file exists
         if(!file_exists(WB_PATH .'/modules/edit_module_files.php')) return;
         // check if specified module directory is valid
         if(check_module_dir($mod_dir) == '') return;
         // check if the quiz data file exists
         $data_file = mod_file_exists($mod_dir .'/data', $page_id .'.' .$section_id .'.txt');
         // output the edit datafile submit button if required
         if($data_file) {
                 // default text used for the edit CSS routines if not defined in the WB core language files
                 $edit_css_caption = (isset($MOD_QUIZ['TXT_EDIT_DATAFILE_B'])) ? $MOD_QUIZ['TXT_EDIT_DATAFILE_B'] : 'Edit Quiz files directly (not recommended!)';
                 ?>
                 <form name="edit_module_datafile" action="<?php echo WB_URL .'/modules/edit_module_files.php?page_id=' .$page_id; ?>" method="post" style="margin: 0; align:right;">
                 <input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
                 <input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
                 <input type="hidden" name="mod_dir" value="<?php echo $mod_dir .'/data'; ?>" />
                 <input type="hidden" name="edit_file" value="<?php echo ($data_file) ? $page_id .'.' .$section_id .'.txt' : ''; ?>" />
                 <input type="hidden" name="action" value="edit" />
                 <input type="submit" value="<?php echo $edit_css_caption;?>" class="mod_<?php echo $mod_dir;?>_edit_datafile" />
                 </form>
                 <?php
         }
}
?>