<?php
/**
  Module QUIZ developed for the Open Source Content Management System Website Baker (http://websitebaker.org)
  Copyright (C) 2012, Andreas Schmidt
  Contact me: webmaster(at)hillschmidt.de, http://www.hillschmidt.de

  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License  - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
**/

// manually include the config.php file (defines the required constants)
require('../../config.php');

// tell the admin wrapper to actualize the DB settings when this page was last updated
$update_when_modified = true;
// include the admin wrapper script (includes framework/class.admin.php)
require(WB_PATH.'/modules/admin.php');

/**
*
*        Make use of: strip_tags, add_slashes, or htmlspecialchars to prevent such kind of things
**/
// get data send via POST using function defined in framework/class.wb.php
// (equivalent to $_POST['simple_output'])
// $admin->get_post prevents output of warnings if the specified value does not exist
$name = $admin->get_post('name');
$display = $admin->get_post('display');
$rate = $admin->get_post('rate');

// remove all HTML, PHP and Javascript tags from the string (we are only interested in the text; nothing else)
$name = strip_tags($name);

// escape special characters (', ", \, NULL byte) before  writing to the database to prevent SQL-injections!!!
// make use of add_slashes (defined in framework/class.wb.php) to prevent double escaping of data derived
// via GET, POST or COOKIES, if magic_quotes_gpc is enabled in the php.ini!!!
$name = $admin->add_slashes($name);

// define field containing the file
$file=strip_tags(dirname(__FILE__) .'/data/' .$page_id .'.' .$section_id .'.txt');
$file=$admin->add_slashes($file);

// now write the text to the database, add unix timestamp to store modification date and time
$sql_query = "UPDATE `" .TABLE_PREFIX ."mod_quiz` SET `name` = '$name', `file` = '$file', `display` = '$display', `rate` = '$rate', `modified_when` = '" .time() ."' WHERE `section_id` = '$section_id'";
$database->query($sql_query);

// Write to the quiz file:
$file=dirname(__FILE__) .'/data/' .$page_id .'.' .$section_id .'.txt';
// erase file and re-open it
unlink($file);
$handler=fOpen($file,"a+");
$num_post=count($_POST);
// 6: two hidden IDs, name, display, rate, delete; 10: Number of Input per  question
$num_quest=($num_post-6)/10;

$subset=0;
for ($counter=0;$counter<$num_quest;$counter++)
{
 if ( $_POST["Quest".$counter] == "") {
  $subset=$subset+1;
 }
 else {
  $FragNo=$counter-$subset;
  $line = $FragNo."|";
  $line = $line . htmlspecialchars($_POST["Quest".$counter],ENT_QUOTES). "|";
  $line = $line . htmlspecialchars($_POST["F".$counter."A1"],ENT_QUOTES)."|";
  $line = $line . htmlspecialchars($_POST["F".$counter."A2"],ENT_QUOTES)."|";
  $line = $line . htmlspecialchars($_POST["F".$counter."A3"],ENT_QUOTES)."|";
  $line = $line . htmlspecialchars($_POST["F".$counter."A4"],ENT_QUOTES)."|";
  $line = $line . htmlspecialchars($_POST["F".$counter."A5"],ENT_QUOTES)."|";
  $line = $line . htmlspecialchars($_POST["F".$counter."A6"],ENT_QUOTES)."|";
  $line = $line . $_POST["F".$counter."Sol"]."|";
  $line = $line . $_POST["QuestPic".$counter]."|\n";
  fPuts($handler, $line);
 }
 if ( $_POST["new"] ) {
  $line_new=$counter-$subset+1;
  $line_new=$line_new+"||||||||||\n";
  fPuts($handler, $line_new);
 }
}
fClose ($handler);

// check if there is a database error, otherwise say successful (functions defined or included via modules/admin.php)
if($database->is_error()) {
        $admin->print_error($database->get_error(), $js_back);
} else {
        $admin->print_success($MESSAGE['PAGES']['SAVED'], ADMIN_URL .'/pages/modify.php?page_id=' .$page_id);
}

// print admin footer
$admin->print_footer()

?>