<?php
/**
  Module developed for the Open Source Content Management System Website Baker (http://websitebaker.org)
  Copyright (C) 2012, Andreas Schmidt
  Contact me: webmaster(at)hillschmidt.de, http://www.hillschmidt.de

  The core part of the quiz itself is the fine php script written by Werner Zenk,
  Homepage: www.homepage-total.de, E-Mail: webmaster@homepage-total.de,
  Quiz - Version: 12.11.2009.

  This module is free software. You can redistribute it and/or modify it
  under the terms of the GNU General Public License  - version 2 or later,
  as published by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  This module is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
**/

// prevent this file from being accessed directly
if(!defined('WB_PATH')) die(header('Location: index.php'));

// check if module language file exists for the language set by the user (e.g. DE, EN)
if(!file_exists(dirname(__FILE__) .'/languages/' .LANGUAGE .'.php')) {
 // no module language file exists for the language set by the user, include default module language file EN.php
 require_once(dirname(__FILE__) .'/languages/EN.php');
} else {
 // a module language file exists for the language defined by the user, load it
 require_once(dirname(__FILE__) .'/languages/' .LANGUAGE .'.php');
}

// check if frontend.css file needs to be included into the <body></body> of view.php
if((!function_exists('register_frontend_modfiles') || !defined('MOD_FRONTEND_CSS_REGISTERED')) &&
        file_exists(dirname(__FILE__) .'/frontend.css')) {
 echo '<style type="text/css">';
 include(dirname(__FILE__) .'/frontend.css');
 echo "\n</style>\n";
}

// obtain data from module DB-table of the current displayed page (unique page defined via section_id)
$sql_result = $database->query("SELECT * FROM `" .TABLE_PREFIX ."mod_quiz` WHERE `section_id` = '$section_id'");

// check if query was sucessfull
if($sql_result->numRows() > 0) {
 // store all results (fields) in the array $sql_row
 $sql_row = $sql_result->fetchRow();

 // NOTE: if you do not want that PHP/Javascript code is parsed in the frontend, make use of strip_tags, htmlspecialchars
 // strip_tags not really required here, as tags were already removed in save.php
 $name = htmlspecialchars(strip_tags($sql_row['name']));
 $file = htmlspecialchars(strip_tags($sql_row['file']));
 // extract whether correct answer will be shown or not: 0=>no; 1=>yes
 $show_solution = htmlspecialchars(strip_tags($sql_row['display']));
 // extract modification date/time (convert timestamp into human readable format using format string in language file)
 $last_modified = date($MOD_QUIZ['DATE_FORMAT_F'], $sql_row['modified_when']);
} else {
 $name = '';
 $file = '';
 $show_solution = '0';
 $last_modified = '';
}

error_reporting(0);

// output the page heading defined in the language file
echo '<h4>' .$MOD_QUIZ['TXT_HEADING_F'] .'</h4>';

if($name != '') {
 // output the quiz text from the database and the text defined in the language file
 $extra = "/modules/quiz/halloffame.php?lang=" .LANGUAGE ."&sort=dd&file=" .$page_id ."." .$section_id ."&called_by=" .$_SERVER['SCRIPT_NAME'] ."&quiz=" .$name;
 echo "<div>" .$MOD_QUIZ['TXT_DESC_F'] .": <br /><h2><span class=\"mod_quiz_emphasise_f\">" .$name ."</span></h2>
 <h4 align=\"right\"><i><a onClick=\"mod_quiz_newWindow_f('" .WB_URL .$extra ."');\">" .$MOD_QUIZ['TXT_HOF_F'] ."</a></i></h4>
 <hr /></div>\n";

 // Minimum % rate for an entry in the Hall of Fame
 $max_points = $sql_row['rate'];

 // Opens file containing the questions
 $quizfile = file($file);
 // Number of question records
 $num_quests = count($quizfile);
 // Check for number of active question
 $quiz_no = isset($_GET["quiz_no"]) ? $_GET["quiz_no"] : 0;

 echo "<form name=\"Form\" action=\"" .$_SERVER['SCRIPT_NAME'] ."?quiz_no=" .($quiz_no + 1) ."\"; method=\"post\" onClick=\"return mod_quiz_force_answer_f('" .$MOD_QUIZ['TXT_ERROR_F'] ."','".LANGUAGE ."');\">\n";

 if ($quiz_no > 0) {
  $points = ((isset($_POST["points"])) ? $_POST["points"] : 0);
  $answer = ((isset($_POST["answer"])) ? $_POST["answer"] : "");
  $last_quest = explode("|", $quizfile[($quiz_no - 1)]);
  if ($answer == $last_quest[8]) {
   $points++;
   echo $show_solution == "1" ? $MOD_QUIZ['TXT_ANSWER_F'] ." <em>&bdquo;$last_quest[1]&rdquo;</em> " .$MOD_QUIZ['TXT_CORRECT_F'] ."<hr />\n" : "\n";
  }
  else {
   echo ($show_solution == "1") ? $MOD_QUIZ['TXT_ANSWER_F'] ." <em>&bdquo;$last_quest[1]&rdquo;</em> " .$MOD_QUIZ['TXT_WRONG_F'] ."\n<br /><b>" .$MOD_QUIZ['TXT_WRONG_LONG_F'] ."</b> <i>" .$last_quest[($last_quest[8] + 1)] ."</i><hr />\n" : "\n";
  }
  echo "<input type=\"hidden\" name=\"points\" value=\"" .$points ."\">\n";
 }

 if ($quiz_no < $num_quests) {
  list($nr, $frage,,,,,,,, $pic) = explode("|", $quizfile[$quiz_no]); $nr=$nr+1;
  echo "$pic<br clear=\"all\" /><strong>Q:</strong> $nr/$num_quests<br />\n<strong>" .$MOD_QUIZ['TXT_Q_F'] .":</strong> <em>$frage</em><br /><br />\n";
  $answer = explode("|", $quizfile[$quiz_no]);
  for ($counter = 2; $counter <= 7; $counter++) {
   if ($answer[$counter] != "") {
    $num = $counter - 1;
    echo "<input type=\"radio\" value=\"$num\" name=\"answer\" id=\"mark$num\">";
    echo "<label for=\"mark$num\">$answer[$counter]</label><br />\n";
   }
  }
  echo "<br /><input type=\"submit\" value=\"" .$MOD_QUIZ['TXT_SUBMIT_F'] ."\">\n</form>\n";
 }
 else {
  echo "</form>\n";
  if ($points != 0) {
   echo $MOD_QUIZ['TXT_YH_F'] ." <b>$points</b> " .($points == 1 ? $MOD_QUIZ['TXT_Q_F'] : $MOD_QUIZ['TXT_QM_F']) ." " .$MOD_QUIZ['TXT_OF_F'] ." <b>$num_quests</b> " .$MOD_QUIZ['TXT_SOME_ANSWER_F'] ."<br />\n";
   // Entry in the Hall Of Fame
   if (($points * 100)/$num_quests >= $max_points) {
    echo "
    <form name=\"edit\" action=\"" .WB_URL ."/modules/quiz/halloffame.php\" method=\"post\" target=\"HallOfFame\" onSubmit=\"mod_quiz_reloc_f('" .WB_URL .$extra ."','" .$_SERVER['SCRIPT_NAME'] ."');\">
    <input type=\"hidden\" name=\"lang\" value=\"" .LANGUAGE ."\">
    <input type=\"hidden\" name=\"sort\" value=\"dd\">
    <input type=\"hidden\" name=\"quiz\" value=\"" .$name ."\">
    <input type=\"hidden\" name=\"called_by\" value=\"" .$_SERVER['SCRIPT_NAME'] ."\">
    <input type=\"hidden\" name=\"file\" value=\"" .$page_id ."." .$section_id ."\">
    <br /><b>" .$MOD_QUIZ['TXT_HOF_ENTRY_F'] .":</b><br />" .$MOD_QUIZ['TXT_WINNER_F'] .":
    <input type=\"text\" name=\"winner\" maxlength=\"30\">
    <input type=\"hidden\" name=\"points\" value=\"" .$points ."\">
    <input type=\"hidden\" name=\"date_time\" value=\"" .date("YmdHis") ."\">
    <input type=\"submit\" value=\"" .$MOD_QUIZ['TXT_SUBMIT_F'] ."\">
    </form>
    ";
   }
  }
  else {
   echo "" .$MOD_QUIZ['TXT_NO_ANSWER_F'] ."<br /><br />\n";
  }
  echo "<br /><a href=\"" .$_SERVER['SCRIPT_NAME'] ."\">" .$MOD_QUIZ['TXT_RESTART_F']."</a>\n";
 }
}
else {
 // no database entry found show a warning
 echo '<p class="mod_quiz_warning_f">' .$MOD_QUIZ['TXT_ERROR_F'] .'</p>';
}

// write out modification time
if($last_modified != "") {
 echo "<h6>" .$MOD_QUIZ['TXT_MODIFIED_F'] .$last_modified ."</h6>\n";
}         
?>